
--this a ship object
ship = {  x=315,
          y=526,
          prev_x=315,
          prev_y=526,
          view_x=315,
          view_y=526,
          speed=3,
          img = love.graphics.newImage("ship.png") }

function love.load()

--I set the game_logic/input update refresh rate to 100 updates per second
love.setUpdateTimestep(1/100)

end


function love.setUpdateTimestep(ts)
  love.updateTimestep = ts
end

function love.run()

  math.randomseed( os.time() )
  math.random() math.random()
  
  if love.load then love.load(arg) end
  
  local dt = 0
  local accumulator = 0
  
  -- Main loop
  while true do
  
    -- Process events.
    if love.event then
      love.event.pump()
      for e,a,b,c,d in love.event.poll() do
        if e == "quit" then
          if not love.quit or not love.quit() then
            if love.audio then love.audio.stop() end
            return
          end
        end
        love.handlers[e](a,b,c,d)
      end
    end
        
    -- Update dt for any uses during this timestep of love.timer.getDelta
    if love.timer then 
      love.timer.step()
      dt = love.timer.getDelta()
    end

    local fixedTimestep = love.updateTimestep
    
    if fixedTimestep then       
      -- see http://gafferongames.com/game-physics/fix-your-timestep  
      
      if dt > 0.25 then      
        dt = 0.25 -- note: max frame time to avoid spiral of death
      end     
      
      accumulator = accumulator + dt
      --_logger:debug("love.run - acc=%f fts=%f", accumulator, fixedTimestep) 

      while accumulator >= fixedTimestep do
        if love.update then love.update(fixedTimestep) end
        accumulator = accumulator - fixedTimestep
      end
      
    else
      -- no fixed timestep in place, so just update
      -- will pass 0 if love.timer is disabled
      if love.update then love.update(dt) end 
    end
      
       local alpha = accumulator/fixedTimestep
      
      ship.view_x = ship.x * alpha + ship.prev_x * (1 - alpha)
      ship.view_y = ship.y * alpha + ship.prev_y * (1 - alpha)
    
    -- draw
    if love.graphics then
      love.graphics.clear()
      if love.draw then love.draw() end
      if love.timer then love.timer.sleep(0.001) end
      love.graphics.present()
    end            
  end
end


function love.update(dt)    
    
    ship.prev_x = ship.x
    ship.prev_y = ship.y
    
    if love.keyboard.isDown('a') then
      ship.x = ship.x - ship.speed
    end
    
    if love.keyboard.isDown('d') then
      ship.x = ship.x + ship.speed
    end
    
    if love.keyboard.isDown('w') then
      ship.y = ship.y - ship.speed
    end
    
    if love.keyboard.isDown('s') then
      ship.y = ship.y + ship.speed
    end
    
end


function love.draw()
 
  love.graphics.draw(ship.img, ship.view_x, ship.view_y)  
  love.graphics.print("Keys [W],[S],[A],[D] for up, down, left & right",6,6)
  love.graphics.print("Frames displayed per second: "..love.timer.getFPS(),6,22)
  
end